!--------------------------------------------------------------------
program check_results
!--------------------------------------------------------------------
  use param
  use dal
  use errorhandling

  implicit none

  character(len=20)   :: filename
  character(len=81)   :: error_message
  integer(kind=int32) :: nmatches, errors=0
  real(kind=double)   :: raoffset, decoffset, rot_corr, lik_hood

  errors=0
  filename = 'xray1a.fits'
  call get_keyword(filename, raoffset, decoffset, rot_corr, lik_hood, nmatches)

  if( abs(raoffset - ( -5.064)) > 0.01 ) errors = errors + 1
  if( abs(decoffset - ( -4.80)) > 0.01 ) errors = errors + 1

  if( abs(rot_corr - 0.0) > 0.01 ) errors = errors + 1
  if( nmatches /= 21 ) errors = errors + 1

  if( abs(lik_hood - 15.378) > 0.1 ) errors = errors + 1



  write(error_message,*) 'Detected ',errors,' errors in file ', filename
  if (errors > 0) call error("test failed",error_message)


!----------------------------------------------------------------
  errors=0
  filename = 'xray2.fits'
  call get_keyword(filename, raoffset, decoffset, rot_corr, lik_hood, nmatches)

  if( abs(raoffset - (-9.07)) > 0.01 ) errors = errors + 1
  if( abs(decoffset - (12.10)) > 0.01 ) errors = errors + 1
  if( abs(rot_corr - 0.0) > 0.01 ) errors = errors + 1
  if( nmatches /= 17 ) errors = errors + 1
  if( abs(lik_hood - 12.446) > 0.1 ) errors = errors + 1

  write(error_message,*) 'Detected ',errors,' errors in file ', filename
  if (errors > 0) call error("test failed",error_message)


end program check_results

!--------------------------------------------------------------------
subroutine get_keyword(filename, raoffset, decoffset, rot_corr, lik_hood, nmatches)
!--------------------------------------------------------------------
  use param
  use dal
  use errorhandling

  implicit none

  character(len=*), intent(in) :: filename
  integer(kind=int32), intent(out):: nmatches
  real(kind=double),intent(out) :: raoffset, decoffset, rot_corr, lik_hood

  type(DataSetT) :: set
  type(TableT)   :: tab

  set = dataSet(filename, read)
  tab = table(set,"SRCLIST")

  raoffset = real32Attribute(tab, "RAOFFSET" )
  decoffset = real32Attribute(tab, "DEOFFSET" )
  rot_corr = real32Attribute(tab, "ROT_CORR" )
  lik_hood = real32Attribute(tab, "LIK_HOOD" )
  nmatches = int32Attribute(tab, "NMATCHES")

  call release(tab)
  call release(set)

end subroutine get_keyword
